<?php

namespace Drupal\commerce_stripe_payment_request_button\Controller;

use Drupal;
use Drupal\commerce_price\Price;

use Drupal\Component\Serialization\Json;
use Drupal\Core\Entity\EntityInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\commerce_stripe_payment_request_button\Services\PaymentRequestButtonHelperServiceInterface;

class PaymentRequestButtonShipping {
  /**
   * The Payment Request button service.
   *
   * @var \Drupal\commerce_stripe_payment_request_button\Services\PaymentRequestButtonHelperServiceInterface
   */
  protected $paymentRequestButtonService;


  public function __construct() {
    $this->paymentRequestButtonService = Drupal::service('commerce_stripe_payment_request_button.helper');
  }

  public function handleShipping(EntityInterface $commerce_order, Request $request) {
    // Transform JSON values to array
    $response['shippingOptions'] = [];
    $values = Json::decode($request->getContent());
    $response['shippingOptions'] = $this->paymentRequestButtonService->getShippingOptions($commerce_order, $values['shippingAddress']);
    return new JsonResponse($response);
  }
}
