<?php

namespace Drupal\commerce_stripe_payment_request_button\EventSubscriber;

use Drupal\commerce_order\Entity\OrderInterface;
use Drupal\commerce_order\Event\OrderEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class OrderSubscriber implements EventSubscriberInterface {
  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    $events = [
      'commerce_stripe_payment_request_button.order.recalculate' => ['triggerRecalculate']
    ];
    return $events;
  }

  /**
   * Used to trigger recalculation and variuous services. For example Avatax.
   *
   * @param \Drupal\commerce_order\Event\OrderEvent\OrderEvent $event
   *   The order transition event.
   */
  public function triggerRecalculate(OrderEvent $event) {
    try {
      /** @var \Drupal\commerce_order\Entity\OrderInterface $order */
      // $order = $event->getOrder();
      // $order->setRefreshState(OrderInterface::REFRESH_ON_SAVE);
      // $order->save();
    } catch (\Exception $e) {
      \Drupal::logger('commerce_stripe_payment_request_button')->error($e->getMessage());
    }
  }
}
